Index: .gitignore
===================================================================
--- .gitignore	(revision 812087205c30d644a123316fb9c3eafe4e952b28)
+++ .gitignore	(revision 599213185275ba58c260d104576bfc9a53f9a838)
Index: client/Makefile
===================================================================
--- client/Makefile	(revision 30beeab008c68e1e024ed39a16b17a5d50ed07a3)
+++ client/Makefile	(revision 4be9aa22de7933179fb80ac24bc7336485a34822)
@@ -4,2 +4,11 @@
 	mkdir -p $(DESTDIR)/usr/bin/
 	install -m 755 bin/* $(DESTDIR)/usr/bin/
+	gzip < bin/gbq.1 > bin/gbq.1.gz
+	gzip < bin/gbr.1 > bin/gbr.1.gz
+	gzip < bin/gbrm.1 > bin/gbrm.1.gz
+	gzip < bin/gutenbach-client-config.1 > bin/gutenbach-client-config.1.gz
+	mkdir -p $(DESTDIR)/usr/share/man/man1/
+	install -m 755 bin/*.1.gz $(DESTDIR)/usr/share/man/man1/
+
+clean:
+	rm bin/*.1.gz
Index: client/bin/gbq.1
===================================================================
--- client/bin/gbq.1	(revision 2c76f34a01141adcc260ec65546aa233191677c2)
+++ client/bin/gbq.1	(revision 2c76f34a01141adcc260ec65546aa233191677c2)
@@ -0,0 +1,16 @@
+.TH gbq 1 "27 June 2010"
+.SH NAME
+gbq \- displays a remote Gutenbach queue
+.SH SYNOPSIS
+.B gbq 
+\fIQUEUE\fR
+.SH DESCRIPTION
+Uses the perl Net::CUPS library to access a remote queue and display
+the current jobs, along with ID numbers, owners, and filenames.  The
+Gutenbach queue must have previously been added with
+.B gutenbach-client-config
+so that gbq knows which host to use.
+.SH SEE ALSO
+gbr(1), gbrm(1), gutenbach-client-config(1)
+.SH AUTHOR
+Jessica Hamrick <jhamrick@mit.edu>
Index: client/bin/gbr.1
===================================================================
--- client/bin/gbr.1	(revision 2c76f34a01141adcc260ec65546aa233191677c2)
+++ client/bin/gbr.1	(revision 2c76f34a01141adcc260ec65546aa233191677c2)
@@ -0,0 +1,15 @@
+.TH gbr 1 "27 June 2010"
+.SH NAME
+gbr \- sends a file to a Gutenbach queue
+.SH SYNOPSIS
+.B gbr 
+\fIQUEUE\fR \fIFILE\fR
+.SH DESCRIPTION
+Prints a file to a Gutenbach queue, given the queue name and the path
+to the file.  The Gutenbach queue must have previously been added with
+.B gutenbach-client-config
+so that gbr knows which host to use.
+.SH SEE ALSO
+gbq(1), gbrm(1), gutenbach-client-config(1)
+.SH AUTHOR
+Jessica Hamrick <jhamrick@mit.edu>
Index: client/bin/gbrm.1
===================================================================
--- client/bin/gbrm.1	(revision 2c76f34a01141adcc260ec65546aa233191677c2)
+++ client/bin/gbrm.1	(revision 2c76f34a01141adcc260ec65546aa233191677c2)
@@ -0,0 +1,20 @@
+.TH gbrm 1 "27 June 2010"
+.SH NAME
+gbrm \- removes jobs from a Gutenbach queue
+.SH SYNOPSIS
+.B gbrm 
+\fIQUEUE\fR [all|\fIID\fR]
+.SH DESCRIPTION
+Removes a single job from a Gutenbach queue, given the job id, which
+can be obtained with the 
+.B gbq
+command.  If 
+.B all
+is used in place of an id, then all jobs are removed from the queue.
+The queue must have previously been added with
+.B gutenbach-client-config
+so that gbrm knows which host to use.
+.SH SEE ALSO
+gbr(1), gbq(1), gutenbach-client-config(1)
+.SH AUTHOR
+Jessica Hamrick <jhamrick@mit.edu>
Index: client/bin/gutenbach-client-config.1
===================================================================
--- client/bin/gutenbach-client-config.1	(revision 2c76f34a01141adcc260ec65546aa233191677c2)
+++ client/bin/gutenbach-client-config.1	(revision 2c76f34a01141adcc260ec65546aa233191677c2)
@@ -0,0 +1,39 @@
+.TH gutenbach-client-config 1 "27 June 2010"
+.SH NAME
+gutenbach-client-config \- displays a remote Gutenbach queue
+.SH SYNOPSIS
+.B gutenbach-client-config 
+[-l|--list|-a|--add|-d|--delete] [\fIQUEUE\fR] [--host \fIHOST\fR]
+.SH DESCRIPTION
+Provides options to add, remove, or list remote Gutenbach queues.  The
+list of queues is stored in the
+.B $HOME/.gutenbach
+directory, with a separate file for each queue.  This means that it is
+not necessary for the local representation of a remote queue to have
+the same name as the remote queue: for example, there could be a file
+in the config directory called "sipb", whose contents specify the
+remote to be "sipbmp3".  Then, when using other commands such as 
+.BR gbr ,
+.BR gbq , 
+or 
+.BR gbrm ,
+you would use "sipb" instead of "sipbmp3".
+.TP
+\fB\-l\fR, \fB\-\-list\fR
+List available queues
+.TP
+\fB\-a\fR, \fB\-\-add\fR QUEUE
+Add a remote queue.  Must be used in conjunction with
+.B --host
+.TP
+\fB\-d\fR, \fB\-\-delete\fR QUEUE
+Delete a remote queue.  Must be used in conjunction with
+.B --host
+.
+.TP
+\fB\-h\fR, \fB\-\-host\fR HOST
+Hostname for the queue
+.SH SEE ALSO
+gbr(1), gbrm(1), gbq(1)
+.SH AUTHOR
+Jessica Hamrick <jhamrick@mit.edu>
Index: queue/Makefile
===================================================================
--- queue/Makefile	(revision 9c0279ee584d72ca543f631999621c6c1afac43e)
+++ queue/Makefile	(revision fad0d1bb1821c9e43d0ae280760ccc747ad92c4f)
@@ -4,2 +4,4 @@
 	mkdir -p $(DESTDIR)/usr/lib/gutenbach/queue/
 	install -m 755 lib/* $(DESTDIR)/usr/lib/gutenbach/queue/
+
+clean:
Index: remctl/Makefile
===================================================================
--- remctl/Makefile	(revision 9c0279ee584d72ca543f631999621c6c1afac43e)
+++ remctl/Makefile	(revision fad0d1bb1821c9e43d0ae280760ccc747ad92c4f)
@@ -6,2 +6,4 @@
 	install -m 755 lib/gutenbach/* $(DESTDIR)/usr/lib/gutenbach/remctl/
 	install -m 755 lib/remctl/* $(DESTDIR)/etc/remctl/conf.d/
+
+clean:
Index: server/Makefile
===================================================================
--- server/Makefile	(revision 9c0279ee584d72ca543f631999621c6c1afac43e)
+++ server/Makefile	(revision fad0d1bb1821c9e43d0ae280760ccc747ad92c4f)
@@ -9,2 +9,4 @@
 	install -m 755 inst/* $(DESTDIR)/usr/lib/gutenbach/inst/
 	install -m 755 rm/* $(DESTDIR)/usr/lib/gutenbach/rm/
+
+clean: